#include "ttl_define.h"

#include "tt_critical_section.h"


TtCriticalSection::TtCriticalSection( void ) :
lock_()
{
  InitializeCriticalSection( &lock_ );
}

TtCriticalSection::~TtCriticalSection()
{
  DeleteCriticalSection( &lock_ );
}

void
TtCriticalSection::Enter( void )
{
  EnterCriticalSection( &lock_ );
}

void
TtCriticalSection::Leave( void )
{
  LeaveCriticalSection( &lock_ );
}


TtCriticalSectionHandler::TtCriticalSectionHandler( TtCriticalSection& obj ) :
obj_( obj )
{
  obj_.Enter();
}

TtCriticalSectionHandler::~TtCriticalSectionHandler()
{
  obj_.Leave();
}
