#include "ttl_define.h"

#include "tt_scroll.h"


int
TtScroll::GetTrackPosition( void )
{
  this->GetInfo();
  return info_.nPos;
}

void
TtScroll::SetTrackPosition( int position )
{
  this->GetInfo();
  info_.nPos = position;
  this->SetInfo();
}

int
TtScroll::GetMinimum( void )
{
  this->GetInfo();
  return info_.nMin;
}

void
TtScroll::SetMinimum( int min )
{
  this->GetInfo();
  info_.nMin = min;
  this->SetInfo();
}

int
TtScroll::GetMaximum( void )
{
  this->GetInfo();
  return info_.nMax;
}

void
TtScroll::SetMaximum( int max )
{
  this->GetInfo();
  info_.nMax = max;
  this->SetInfo();
}

void
TtScroll::SetRange( int min, int max )
{
  this->GetInfo();
  info_.nMin = min;
  info_.nMax = max;
  this->SetInfo();
}

int
TtScroll::GetPageSize( void )
{
  this->GetInfo();
  return info_.nPage;
}

void
TtScroll::SetPageSize( int page_size )
{
  this->GetInfo();
  info_.nPage = page_size;
  this->SetInfo();
}

bool TtScroll::GetInfo( void )
{
  info_.fMask = SIF_ALL;
  return GetScrollInfo( this->GetHandle(), SB_CTL, &info_ );
}

void TtScroll::SetInfo( void )
{
  info_.fMask |= SIF_DISABLENOSCROLL;
  SetScrollInfo( this->GetHandle(), SB_CTL, &info_, TRUE );
}

LRESULT
TtScroll::Scrolling( int code, int position )
{
  this->GetInfo();
  switch ( code ) {
  case SB_LEFT:
    info_.nPos = info_.nMin;
    break;

  case SB_RIGHT:
    info_.nPos = info_.nMax;
    break;

  case SB_LINELEFT:
    if ( info_.nPos > info_.nMin ) {
      info_.nPos -= 1;
    }
    break;

  case SB_LINERIGHT:
    if ( info_.nPos < info_.nMax - 1 ) {
      info_.nPos += 1;
    }
    break;

  case SB_PAGELEFT:
    info_.nPos -= info_.nPage;
    if ( info_.nPos < info_.nMin ) {
      info_.nPos = info_.nMin;
    }
    break;

  case SB_PAGERIGHT:
    info_.nPos += info_.nPage;
    if ( info_.nPos > info_.nMax ) {
      info_.nPos = info_.nMax;
    }
    break;

  case SB_THUMBPOSITION:
    info_.nPos = position;
    break;

  default:
    return TtWindow::MSG_DEFAULT;
  }
  this->SetInfo();
  return 0;
}

// -- TtScrollVertical ---------------------------------------------------
LRESULT
TtScrollVertical::WMVerticalScrollReceived( int code, int position, HWND handle )
{
  NOT_USE_VAR( handle );
  return this->Scrolling( code, position );
}

// -- TtScrollVertical ---------------------------------------------------
LRESULT
TtScrollHorizontal::WMHorizontalScrollReceived( int code, int position, HWND handle )
{
  NOT_USE_VAR( handle );
  return this->Scrolling( code, position );
}
