#include "tt_squirrel_exception.h"

using namespace TtSquirrel;


// -- Exception ----------------------------------------------------------

// -- SquirrelAPIException -----------------------------------------------
SquirrelAPIException::SquirrelAPIException( const std::string& function_name ) :
function_name_( function_name )
{
}

std::string
SquirrelAPIException::GetFunctionName( void )
{
  return function_name_;
}


// -- ObjectTypeException ------------------------------------------------
ObjectTypeException::ObjectTypeException( ObjectType actual, ObjectType require ) :
actual_( actual ),
require_( require )
{
}

ObjectType
ObjectTypeException::GetActualType( void ) const
{
  return actual_;
}

ObjectType
ObjectTypeException::GetRequireType( void ) const
{
  return require_;
}
