#ifndef TT_SQUIRREL_EXCEPTION_H_
#define TT_SQUIRREL_EXCEPTION_H_

#include <string>

#include "tt_exception.h"

#include "tt_squirrel_object_type.h"

namespace TtSquirrel {
  // -- Exception --------------------------------------------------------
  class Exception : public TtException {};

  // -- SquirrelAPIException ---------------------------------------------
  class SquirrelAPIException : public Exception {
  public:
    explicit SquirrelAPIException( const std::string& function_name );

    std::string GetFunctionName( void );

  private:
    std::string function_name_;
  };

  // -- ObjectTypeException ----------------------------------------------
  class ObjectTypeException : public Exception {
  public:
    explicit ObjectTypeException( ObjectType actual, ObjectType require );

    ObjectType GetActualType( void ) const;
    ObjectType GetRequireType( void ) const;

  private:
    ObjectType actual_;
    ObjectType require_;
  };
}

#endif // TT_SQUIRREL_EXCEPTION_H_
