#include <time.h>
#include <windows.h>

#include "ttl_define.h"

#include "tt_time.h"


TtTime
TtTime::GetNow( void )
{
  return TtTime();
}


TtTime::TtTime( void )
{
  SYSTEMTIME systemTime;
  GetLocalTime( &systemTime );

  serial_second_ = time( NULL );
  year_          = systemTime.wYear;
  month_         = systemTime.wMonth;
  day_of_month_  = systemTime.wDay;
  hour_          = systemTime.wHour;
  minute_        = systemTime.wMinute;
  second_        = systemTime.wSecond;
  milli_second_  = systemTime.wMilliseconds;
}

INT64
TtTime::GetSerialSecond( void ) const
{
  return serial_second_;
}

unsigned int
TtTime::GetYear( void ) const
{
  return year_;
}

unsigned int
TtTime::GetMonth( void ) const
{
  return month_;
}

unsigned int
TtTime::GetDayOfMonth( void ) const
{
  return day_of_month_;
}

unsigned int
TtTime::GetHour( void ) const
{
  return hour_;
}

unsigned int
TtTime::GetMinute( void ) const
{
  return minute_;
}

unsigned int
TtTime::GetSecond( void ) const
{
  return second_;
}

unsigned int
TtTime::GetMilliSecond( void ) const
{
  return milli_second_;
}

double
TtTime::operator -( const TtTime& r ) const
{
  return (
    static_cast<double>( serial_second_ ) - static_cast<double>( r.serial_second_ ) +
    (static_cast<double>( milli_second_ ) - static_cast<double>( r.milli_second_ )) / 1000.0 );
}
