#include "ttl_define.h"
#include "tt_window.h"

#include "tt_track.h"


int
TtTrack::GetTrackPosition( void )
{
  return this->SendMessage( TBM_GETPOS, 0, 0 );
}

void
TtTrack::SetTrackPosition( int position )
{
  this->SendMessage( TBM_SETPOS, TRUE, position );
}

int
TtTrack::GetMinimum( void )
{
  return this->SendMessage( TBM_GETRANGEMIN, 0, 0 );
}

void
TtTrack::SetMinimum( int min )
{
  this->SendMessage( TBM_SETRANGEMIN, TRUE, min );
}

int
TtTrack::GetMaximum( void )
{
  return this->SendMessage( TBM_GETRANGEMAX, 0, 0 );
}

void
TtTrack::SetMaximum( int max )
{
  this->SendMessage( TBM_SETRANGEMAX, TRUE, max );
}

void
TtTrack::SetRange( int min, int max )
{
  this->SetMinimum( min );
  this->SetMaximum( max );
}

int
TtTrack::GetPageSize( void )
{
  return this->SendMessage( TBM_GETPAGESIZE, 0, 0 );
}

void
TtTrack::SetPageSize( int page_size )
{
  this->SendMessage( TBM_SETPAGESIZE, 0, page_size );
}

int
TtTrack::GetLineSize( void )
{
  return this->SendMessage( TBM_GETLINESIZE, 0, 0 );
}

void
TtTrack::SetLineSize( int line_size )
{
  this->SendMessage( TBM_SETLINESIZE, 0, line_size );
}

void
TtTrack::SetTickFrequency( unsigned int frequency )
{
  this->SendMessage( TBM_SETTICFREQ, frequency, 0 );
}

void
TtTrack::ClearTick( void )
{
  this->SendMessage( TBM_CLEARTICS, TRUE, 0 );
}


LRESULT
TtTrack::WMVerticalScrollReceived( int code, int position, HWND handle )
{
  NOT_USE_VAR( code );
  NOT_USE_VAR( position );
  NOT_USE_VAR( handle );
  return TtWindow::MSG_DEFAULT;
}

LRESULT
TtTrack::WMHorizontalScrollReceived( int code, int position, HWND handle )
{
  NOT_USE_VAR( code );
  NOT_USE_VAR( position );
  NOT_USE_VAR( handle );
  return TtWindow::MSG_DEFAULT;
}
